﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Serialization.Formatters;
using System.Text;
using System.Threading.Tasks;

namespace ShareProgram
{
    public class PatchTCP
    {

        public static IChannel GetChannel(int tcpPort, bool isSecure, int c)
        {
            BinaryServerFormatterSinkProvider serverProv =
                new BinaryServerFormatterSinkProvider();
            ClientIPServerSinkProvider csp = new ClientIPServerSinkProvider();
            csp.Next = serverProv;
            serverProv.TypeFilterLevel = TypeFilterLevel.Full;
            IDictionary propBag = new Hashtable();

            if (tcpPort != -1)
                propBag["port"] = tcpPort;
            else
            {
                // propBag["port"] = 0;

            }
            if (c == 1)
            {
                propBag["contract"] = "IT.ADC";
            }
            propBag["typeFilterLevel"] = TypeFilterLevel.Full;
            propBag["name"] = Guid.NewGuid().ToString();
            //propBag["name"] = c == 0 ? "{F76B0CD3-9BC4-41BF-B807-FC94B0168C6B}" : "{FBB4F891-AA64-4197-B478-5702314A8C46}";
            propBag["secure"] = isSecure;
            if (isSecure)
            {

                propBag["impersonate"] = true;
                propBag["connectionTimeout"] = 5000;
                propBag["tokenImpersonationLevel"] = "Impersonation";
            }
            else
            {
                //propBag["impersonate"] = false;
                // propBag["tokenImpersonationLevel"] = "None";
            }
            return new TcpChannel(
                propBag, null, csp);
        }

    }
}
